/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as Flatfile from "../../../index";
export declare namespace Accounts {
    interface Options {
        environment?: core.Supplier<environments.FlatfileEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        token?: core.Supplier<core.BearerToken | undefined>;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Accounts {
    protected readonly _options: Accounts.Options;
    constructor(_options?: Accounts.Options);
    /**
     * Get the current account
     *
     * @param {Accounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounts.getCurrent()
     */
    getCurrent(requestOptions?: Accounts.RequestOptions): core.HttpResponsePromise<Flatfile.AccountResponse>;
    private __getCurrent;
    /**
     * Update the current account
     *
     * @param {Flatfile.AccountPatch} request
     * @param {Accounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounts.updateCurrent({
     *         name: "My Company Name",
     *         defaultAppId: "us_app_YOUR_ID"
     *     })
     */
    updateCurrent(request: Flatfile.AccountPatch, requestOptions?: Accounts.RequestOptions): core.HttpResponsePromise<Flatfile.AccountResponse>;
    private __updateCurrent;
    protected _getAuthorizationHeader(): Promise<string | undefined>;
}
