/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Flatfile from "../../../index";
/**
 * The context of the event
 *
 * @example
 *     {
 *         accountId: "us_acc_YOUR_ID",
 *         actorId: "us_key_SOME_KEY",
 *         environmentId: "us_env_YOUR_ID",
 *         spaceId: "us_sp_YOUR_ID",
 *         workbookId: "us_wb_YOUR_ID"
 *     }
 */
export interface Context {
    /** The namespaces of the event */
    namespaces?: string[];
    /** The slugs of related resources */
    slugs?: Flatfile.EventContextSlugs;
    actionName?: Flatfile.ActionName;
    accountId: Flatfile.AccountId;
    environmentId: Flatfile.EnvironmentId;
    spaceId?: Flatfile.SpaceId;
    workbookId?: Flatfile.WorkbookId;
    sheetId?: Flatfile.SheetId;
    sheetSlug?: Flatfile.SheetSlug;
    snapshotId?: Flatfile.SnapshotId;
    /** Deprecated, use `commitId` instead. */
    versionId?: Flatfile.VersionId;
    commitId?: Flatfile.CommitId;
    jobId?: Flatfile.JobId;
    programId?: Flatfile.ProgramId;
    fileId?: Flatfile.FileId;
    documentId?: Flatfile.DocumentId;
    precedingEventId?: Flatfile.EventId;
    /** Can be a UserId, GuestId, or AgentId */
    actorId?: string;
    appId?: Flatfile.AppId;
    actionId?: Flatfile.ActionId;
    dataClipId?: Flatfile.DataClipId;
    threadId?: Flatfile.ThreadId;
    filters?: Record<string, string>;
    entityId?: string;
}
