/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Flatfile from "../../../index";
/**
 * A message in a thread with an assignable role (system, user, assistant, tool)
 *
 * @example
 *     {
 *         id: "us_msg_123abc",
 *         threadId: "us_th_456def",
 *         content: {
 *             "text": "Hello, how can I help you today?"
 *         },
 *         createdAt: "2025-04-01T10:30:00Z",
 *         updatedAt: "2025-04-01T10:30:00Z",
 *         role: Flatfile.MessageRole.Assistant,
 *         metadata: {
 *             "source": "api"
 *         },
 *         state: {
 *             "processingStatus": "complete"
 *         }
 *     }
 */
export interface MessageModel {
    id: Flatfile.MessageId;
    threadId: Flatfile.ThreadId;
    /** The message content */
    content: Record<string, any>;
    createdAt: Date;
    updatedAt: Date;
    /** The role of the message sender */
    role: Flatfile.MessageRole;
    /** Persistent state for the message */
    state?: Record<string, any>;
    /** Additional metadata associated with the message */
    metadata?: Record<string, any>;
}
