/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Flatfile from "../../../index";
/**
 * Routine is a set of instructions or procedures that are followed to complete a task.
 *
 * @example
 *     {
 *         id: "us_rtn_YOUR_ID",
 *         runbookId: "us_rb_YOUR_ID",
 *         name: "Split Address to Street, City, State, Zip",
 *         config: {
 *             "sourceSheetId": "us_sh_YOUR_ID",
 *             "destinationSheetId": "us_sh_YOUR_ID",
 *             "programId": "us_mp_YOUR_ID"
 *         },
 *         ordinal: 1,
 *         type: Flatfile.RoutineType.Job,
 *         createdBy: "us_usr_YOUR_ID",
 *         createdAt: "2024-12-05T00:00:00Z",
 *         updatedAt: "2024-12-05T00:00:00Z"
 *     }
 */
export interface Routine {
    /** The ID of the Routine. */
    id: Flatfile.RoutineId;
    runbookId: Flatfile.RunbookId;
    /** The name of the Routine. */
    name: string;
    /** Configuration for the Routine. Related to the type of Routine. */
    config?: any;
    /** The order of the Routine in the Runbook. */
    ordinal: number;
    /** The type of Routine. */
    type: Flatfile.RoutineType;
    /** The entity which created the Runbook. */
    createdBy: string;
    /** Date the sheet was created */
    createdAt: Date;
    /** Date the sheet was last updated */
    updatedAt: Date;
}
