/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Flatfile from "../../../index";
/**
 * A thread containing messages with a specific resource association
 *
 * @example
 *     {
 *         id: "us_th_123abc",
 *         resourceId: "us_sp_456def",
 *         metadata: {
 *             "origin": "customer-chat"
 *         },
 *         source: "web",
 *         state: {
 *             "lastInteraction": "2025-04-01T15:30:00Z"
 *         },
 *         status: Flatfile.ThreadStatus.Active,
 *         createdAt: "2025-04-01T12:00:00Z",
 *         updatedAt: "2025-04-01T15:30:00Z"
 *     }
 */
export interface ThreadModel {
    id: Flatfile.ThreadId;
    /** The resource ID this thread is associated with */
    resourceId: string;
    /** Additional metadata associated with the thread */
    metadata?: Flatfile.ThreadMetadata;
    /** The source/origin of this thread */
    source?: string;
    /** Persistent state for the thread */
    state?: Flatfile.ThreadState;
    /** Current status of the thread */
    status: Flatfile.ThreadStatus;
    /** When the thread was created */
    createdAt: Date;
    /** When the thread was last updated */
    updatedAt: Date;
}
