/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as Flatfile from "../../../index";
export declare namespace Versions {
    interface Options {
        environment?: core.Supplier<environments.FlatfileEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        token?: core.Supplier<core.BearerToken | undefined>;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Versions {
    protected readonly _options: Versions.Options;
    constructor(_options?: Versions.Options);
    /**
     * @param {Flatfile.VersionsPostRequestBody} request
     * @param {Versions.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.versions.createId({
     *         sheetId: "us_sh_YOUR_ID",
     *         parentVersionId: "us_vr_YOUR_ID"
     *     })
     */
    createId(request?: Flatfile.VersionsPostRequestBody, requestOptions?: Versions.RequestOptions): core.HttpResponsePromise<Flatfile.VersionResponse>;
    private __createId;
    protected _getAuthorizationHeader(): Promise<string | undefined>;
}
