/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "./environments";
import * as core from "./core";
import { Accounts } from "./api/resources/accounts/client/Client";
import { Actions } from "./api/resources/actions/client/Client";
import { AgentExports } from "./api/resources/agentExports/client/Client";
import { Agents } from "./api/resources/agents/client/Client";
import { Apps } from "./api/resources/apps/client/Client";
import { Assistant } from "./api/resources/assistant/client/Client";
import { Auth } from "./api/resources/auth/client/Client";
import { CanvasAreas } from "./api/resources/canvasAreas/client/Client";
import { Cells } from "./api/resources/cells/client/Client";
import { Commits } from "./api/resources/commits/client/Client";
import { DataRetentionPolicies } from "./api/resources/dataRetentionPolicies/client/Client";
import { Documents } from "./api/resources/documents/client/Client";
import { Entitlements } from "./api/resources/entitlements/client/Client";
import { Environments } from "./api/resources/environments/client/Client";
import { Events } from "./api/resources/events/client/Client";
import { Files } from "./api/resources/files/client/Client";
import { Foreigndb } from "./api/resources/foreigndb/client/Client";
import { Guests } from "./api/resources/guests/client/Client";
import { Jobs } from "./api/resources/jobs/client/Client";
import { Mapping } from "./api/resources/mapping/client/Client";
import { Messages } from "./api/resources/messages/client/Client";
import { OnboardingDatapoints } from "./api/resources/onboardingDatapoints/client/Client";
import { Onboardings } from "./api/resources/onboardings/client/Client";
import { Records } from "./api/resources/records/client/Client";
import { Roles } from "./api/resources/roles/client/Client";
import { Routines } from "./api/resources/routines/client/Client";
import { Runbooks } from "./api/resources/runbooks/client/Client";
import { Secrets } from "./api/resources/secrets/client/Client";
import { Sheets } from "./api/resources/sheets/client/Client";
import { Snapshots } from "./api/resources/snapshots/client/Client";
import { Spaces } from "./api/resources/spaces/client/Client";
import { Threads } from "./api/resources/threads/client/Client";
import { Transformations } from "./api/resources/transformations/client/Client";
import { Users } from "./api/resources/users/client/Client";
import { Versions } from "./api/resources/versions/client/Client";
import { Views } from "./api/resources/views/client/Client";
import { Workbooks } from "./api/resources/workbooks/client/Client";
export declare namespace FlatfileClient {
    interface Options {
        environment?: core.Supplier<environments.FlatfileEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        token?: core.Supplier<core.BearerToken | undefined>;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class FlatfileClient {
    protected readonly _options: FlatfileClient.Options;
    protected _accounts: Accounts | undefined;
    protected _actions: Actions | undefined;
    protected _agentExports: AgentExports | undefined;
    protected _agents: Agents | undefined;
    protected _apps: Apps | undefined;
    protected _assistant: Assistant | undefined;
    protected _auth: Auth | undefined;
    protected _canvasAreas: CanvasAreas | undefined;
    protected _cells: Cells | undefined;
    protected _commits: Commits | undefined;
    protected _dataRetentionPolicies: DataRetentionPolicies | undefined;
    protected _documents: Documents | undefined;
    protected _entitlements: Entitlements | undefined;
    protected _environments: Environments | undefined;
    protected _events: Events | undefined;
    protected _files: Files | undefined;
    protected _foreigndb: Foreigndb | undefined;
    protected _guests: Guests | undefined;
    protected _jobs: Jobs | undefined;
    protected _mapping: Mapping | undefined;
    protected _messages: Messages | undefined;
    protected _onboardingDatapoints: OnboardingDatapoints | undefined;
    protected _onboardings: Onboardings | undefined;
    protected _records: Records | undefined;
    protected _roles: Roles | undefined;
    protected _routines: Routines | undefined;
    protected _runbooks: Runbooks | undefined;
    protected _secrets: Secrets | undefined;
    protected _sheets: Sheets | undefined;
    protected _snapshots: Snapshots | undefined;
    protected _spaces: Spaces | undefined;
    protected _threads: Threads | undefined;
    protected _transformations: Transformations | undefined;
    protected _users: Users | undefined;
    protected _versions: Versions | undefined;
    protected _views: Views | undefined;
    protected _workbooks: Workbooks | undefined;
    constructor(_options?: FlatfileClient.Options);
    get accounts(): Accounts;
    get actions(): Actions;
    get agentExports(): AgentExports;
    get agents(): Agents;
    get apps(): Apps;
    get assistant(): Assistant;
    get auth(): Auth;
    get canvasAreas(): CanvasAreas;
    get cells(): Cells;
    get commits(): Commits;
    get dataRetentionPolicies(): DataRetentionPolicies;
    get documents(): Documents;
    get entitlements(): Entitlements;
    get environments(): Environments;
    get events(): Events;
    get files(): Files;
    get foreigndb(): Foreigndb;
    get guests(): Guests;
    get jobs(): Jobs;
    get mapping(): Mapping;
    get messages(): Messages;
    get onboardingDatapoints(): OnboardingDatapoints;
    get onboardings(): Onboardings;
    get records(): Records;
    get roles(): Roles;
    get routines(): Routines;
    get runbooks(): Runbooks;
    get secrets(): Secrets;
    get sheets(): Sheets;
    get snapshots(): Snapshots;
    get spaces(): Spaces;
    get threads(): Threads;
    get transformations(): Transformations;
    get users(): Users;
    get versions(): Versions;
    get views(): Views;
    get workbooks(): Workbooks;
}
