/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as Flatfile from "../../../index";
export declare namespace Actions {
    interface Options {
        environment?: core.Supplier<environments.FlatfileEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        token?: core.Supplier<core.BearerToken | undefined>;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Actions {
    protected readonly _options: Actions.Options;
    constructor(_options?: Actions.Options);
    /**
     * @param {Flatfile.ActionCreateRequest} request
     * @param {Actions.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.actions.create({
     *         spaceId: "spaceId",
     *         body: {
     *             label: "label",
     *             targetId: "targetId"
     *         }
     *     })
     */
    create(request: Flatfile.ActionCreateRequest, requestOptions?: Actions.RequestOptions): core.HttpResponsePromise<Flatfile.ApiActionResponse>;
    private __create;
    /**
     * @param {Flatfile.ActionsBulkCreateRequest} request
     * @param {Actions.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.actions.bulkCreate({
     *         spaceId: "spaceId",
     *         body: [{
     *                 label: "label",
     *                 targetId: "targetId"
     *             }, {
     *                 label: "label",
     *                 targetId: "targetId"
     *             }]
     *     })
     */
    bulkCreate(request: Flatfile.ActionsBulkCreateRequest, requestOptions?: Actions.RequestOptions): core.HttpResponsePromise<Flatfile.ApiActionsResponse>;
    private __bulkCreate;
    /**
     * @param {Flatfile.GetActionsRequest} request
     * @param {Actions.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.actions.getAll({
     *         spaceId: "spaceId"
     *     })
     */
    getAll(request: Flatfile.GetActionsRequest, requestOptions?: Actions.RequestOptions): core.HttpResponsePromise<Flatfile.ApiActionsResponse>;
    private __getAll;
    /**
     * @param {Flatfile.ActionId} actionId - The id of the action to return
     * @param {Actions.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.actions.get("actionId")
     */
    get(actionId: Flatfile.ActionId, requestOptions?: Actions.RequestOptions): core.HttpResponsePromise<Flatfile.ApiActionResponse>;
    private __get;
    /**
     * @param {Flatfile.ActionId} actionId - The id of the action to patch
     * @param {Flatfile.ActionUpdate} request
     * @param {Actions.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.actions.update("actionId", {})
     */
    update(actionId: Flatfile.ActionId, request: Flatfile.ActionUpdate, requestOptions?: Actions.RequestOptions): core.HttpResponsePromise<Flatfile.ApiActionResponse>;
    private __update;
    /**
     * @param {Flatfile.ActionId} actionId - The id of the action to delete
     * @param {Actions.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.actions.delete("actionId")
     */
    delete(actionId: Flatfile.ActionId, requestOptions?: Actions.RequestOptions): core.HttpResponsePromise<Flatfile.Success>;
    private __delete;
    protected _getAuthorizationHeader(): Promise<string | undefined>;
}
