/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as Flatfile from "../../../index";
import * as stream from "stream";
export declare namespace AgentExports {
    interface Options {
        environment?: core.Supplier<environments.FlatfileEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        token?: core.Supplier<core.BearerToken | undefined>;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class AgentExports {
    protected readonly _options: AgentExports.Options;
    constructor(_options?: AgentExports.Options);
    /**
     * @param {Flatfile.ListAgentExportsRequest} request
     * @param {AgentExports.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.agentExports.list()
     */
    list(request?: Flatfile.ListAgentExportsRequest, requestOptions?: AgentExports.RequestOptions): core.HttpResponsePromise<Flatfile.ListAgentExportsResponse>;
    private __list;
    /**
     * @param {Flatfile.AgentExportId} agentExportId
     * @param {AgentExports.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.agentExports.get("us_agx_YOUR_ID")
     */
    get(agentExportId: Flatfile.AgentExportId, requestOptions?: AgentExports.RequestOptions): core.HttpResponsePromise<Flatfile.GetAgentExportResponse>;
    private __get;
    download(agentExportId: Flatfile.AgentExportId, requestOptions?: AgentExports.RequestOptions): core.HttpResponsePromise<stream.Readable>;
    private __download;
    /**
     * @param {Flatfile.AgentExportId} agentExportId
     * @param {AgentExports.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.agentExports.delete("us_agx_YOUR_ID")
     */
    delete(agentExportId: Flatfile.AgentExportId, requestOptions?: AgentExports.RequestOptions): core.HttpResponsePromise<Flatfile.Success>;
    private __delete;
    protected _getAuthorizationHeader(): Promise<string | undefined>;
}
