/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Flatfile from "../../../index";
/**
 * Properties used to create a new agent
 *
 * @example
 *     {
 *         topics: [Flatfile.EventTopic.WorkbookUpdated],
 *         compiler: Flatfile.Compiler.Js,
 *         source: "module.exports = { routeEvent: async (...args) => { console.log(args) } }",
 *         options: {
 *             "namespace": "space:blue"
 *         }
 *     }
 */
export interface AgentConfig {
    /** The topics the agent should listen for */
    topics?: Flatfile.EventTopic[];
    /** The compiler of the agent */
    compiler?: Flatfile.Compiler;
    /** The source of the agent */
    source?: string;
    /** The source map of the agent */
    sourceMap?: string;
    /** The slug of the agent */
    slug?: string;
    /** Options for the agent */
    options?: Record<string, any>;
    /** Whether the agent is a system agent. This should be false for all agents created by users. */
    isSystem?: boolean;
    /** The namespace this agent should be limited to. Right now, this is information only and not used to actually filter agents that run, so you must still specify the namespace filter in the agent code. */
    namespace?: string;
    /** Package versions information for the agent */
    packageVersions?: Record<string, string>;
    /** Commit information for the agent */
    commitInfo?: Record<string, any>;
}
