/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as Flatfile from "../../../index";
export declare namespace Assistant {
    interface Options {
        environment?: core.Supplier<environments.FlatfileEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        token?: core.Supplier<core.BearerToken | undefined>;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Assistant {
    protected readonly _options: Assistant.Options;
    constructor(_options?: Assistant.Options);
    /**
     * Returns prompts created by user
     *
     * @param {Flatfile.ListPromptsRequest} request
     * @param {Assistant.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.assistant.list()
     */
    list(request?: Flatfile.ListPromptsRequest, requestOptions?: Assistant.RequestOptions): core.HttpResponsePromise<Flatfile.PromptsResponse>;
    private __list;
    /**
     * Returns a prompt
     *
     * @param {Flatfile.PromptId} promptId - ID of prompts
     * @param {Assistant.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.assistant.get("us_pr_YOUR_ID")
     */
    get(promptId: Flatfile.PromptId, requestOptions?: Assistant.RequestOptions): core.HttpResponsePromise<Flatfile.PromptResponse>;
    private __get;
    /**
     * Updates a prompt
     *
     * @param {Flatfile.PromptId} promptId - ID of prompts
     * @param {Flatfile.PromptPatch} request
     * @param {Assistant.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.assistant.update("us_pr_YOUR_ID", {
     *         prompt: "Combine first name and last name into a new column called Full Name"
     *     })
     */
    update(promptId: Flatfile.PromptId, request: Flatfile.PromptPatch, requestOptions?: Assistant.RequestOptions): core.HttpResponsePromise<Flatfile.PromptResponse>;
    private __update;
    /**
     * Creates a prompt
     *
     * @param {Flatfile.PromptCreate} request
     * @param {Assistant.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.assistant.create({
     *         prompt: "Combine first name and last name into a new column called Full Name",
     *         environmentId: "us_env_YOUR_ID",
     *         spaceId: "us_sp_YOUR_ID"
     *     })
     */
    create(request: Flatfile.PromptCreate, requestOptions?: Assistant.RequestOptions): core.HttpResponsePromise<Flatfile.PromptResponse>;
    private __create;
    /**
     * Deletes a prompts
     *
     * @param {Flatfile.PromptId} promptId - ID of prompts
     * @param {Assistant.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.assistant.delete("us_pr_YOUR_ID")
     */
    delete(promptId: Flatfile.PromptId, requestOptions?: Assistant.RequestOptions): core.HttpResponsePromise<Flatfile.Success>;
    private __delete;
    protected _getAuthorizationHeader(): Promise<string | undefined>;
}
