/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as Flatfile from "../../../index";
export declare namespace Entitlements {
    interface Options {
        environment?: core.Supplier<environments.FlatfileEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        token?: core.Supplier<core.BearerToken | undefined>;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Entitlements {
    protected readonly _options: Entitlements.Options;
    constructor(_options?: Entitlements.Options);
    /**
     * Returns all entitlements matching a filter for resourceId
     *
     * @param {Flatfile.ListEntitlementsRequest} request
     * @param {Entitlements.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link Flatfile.BadRequestError}
     * @throws {@link Flatfile.NotFoundError}
     *
     * @example
     *     await client.entitlements.list({
     *         resourceId: "string"
     *     })
     */
    list(request: Flatfile.ListEntitlementsRequest, requestOptions?: Entitlements.RequestOptions): core.HttpResponsePromise<Flatfile.ListEntitlementsResponse>;
    private __list;
    protected _getAuthorizationHeader(): Promise<string | undefined>;
}
