/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as Flatfile from "../../../index";
import * as fs from "fs";
import { Blob } from "buffer";
import * as stream from "stream";
export declare namespace Files {
    interface Options {
        environment?: core.Supplier<environments.FlatfileEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        token?: core.Supplier<core.BearerToken | undefined>;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Files {
    protected readonly _options: Files.Options;
    constructor(_options?: Files.Options);
    /**
     * @param {Flatfile.ListFilesRequest} request
     * @param {Files.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.files.list()
     */
    list(request?: Flatfile.ListFilesRequest, requestOptions?: Files.RequestOptions): core.HttpResponsePromise<Flatfile.ListFilesResponse>;
    private __list;
    /**
     * @param {File | fs.ReadStream | Blob} file
     * @param {Flatfile.CreateFileRequest} request
     * @param {Files.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link Flatfile.BadRequestError}
     */
    upload(file: File | fs.ReadStream | Blob, request: Flatfile.CreateFileRequest, requestOptions?: Files.RequestOptions): core.HttpResponsePromise<Flatfile.FileResponse>;
    private __upload;
    /**
     * @param {string} fileId
     * @param {Files.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link Flatfile.BadRequestError}
     * @throws {@link Flatfile.NotFoundError}
     *
     * @example
     *     await client.files.get("us_fl_YOUR_ID")
     */
    get(fileId: string, requestOptions?: Files.RequestOptions): core.HttpResponsePromise<Flatfile.FileResponse>;
    private __get;
    /**
     * @param {string} fileId
     * @param {Files.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link Flatfile.BadRequestError}
     * @throws {@link Flatfile.NotFoundError}
     *
     * @example
     *     await client.files.delete("fileId")
     */
    delete(fileId: string, requestOptions?: Files.RequestOptions): core.HttpResponsePromise<Flatfile.Success>;
    private __delete;
    /**
     * Update a file, to change the workbook id for example
     *
     * @param {string} fileId - ID of file to update
     * @param {Flatfile.UpdateFileRequest} request
     * @param {Files.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link Flatfile.BadRequestError}
     * @throws {@link Flatfile.NotFoundError}
     *
     * @example
     *     await client.files.update("us_fl_YOUR_ID", {
     *         name: "NewFileName"
     *     })
     */
    update(fileId: string, request?: Flatfile.UpdateFileRequest, requestOptions?: Files.RequestOptions): core.HttpResponsePromise<Flatfile.FileResponse>;
    private __update;
    /**
     * @throws {@link Flatfile.BadRequestError}
     * @throws {@link Flatfile.NotFoundError}
     */
    download(fileId: Flatfile.FileId, requestOptions?: Files.RequestOptions): core.HttpResponsePromise<stream.Readable>;
    private __download;
    protected _getAuthorizationHeader(): Promise<string | undefined>;
}
