/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Flatfile from "../../../index";
/**
 * A single unit of work that will execute asynchronously
 *
 * @example
 *     {
 *         id: "us_jb_YOUR_ID",
 *         createdBy: "us_usr_YOUR_ID",
 *         createdAt: "2023-10-30T20:04:28.556Z",
 *         updatedAt: "2023-10-30T20:04:32.075Z",
 *         startedAt: "2023-10-30T20:04:29.453Z",
 *         finishedAt: "2023-10-30T20:04:32.074Z",
 *         environmentId: "us_env_YOUR_ID",
 *         type: Flatfile.JobType.Workbook,
 *         operation: "submitAction",
 *         source: "us_wb_YOUR_ID",
 *         destination: "us_wb_YOUR_ID",
 *         config: {},
 *         trigger: Flatfile.Trigger.Immediate,
 *         status: Flatfile.JobStatus.Complete,
 *         progress: 100,
 *         fileId: "us_fl_YOUR_ID",
 *         mode: Flatfile.JobMode.Foreground,
 *         input: {},
 *         subject: {
 *             type: "resource",
 *             id: "us_wb_YOUR_ID"
 *         },
 *         outcome: {
 *             "message": "Data was successfully submitted to Webhook.site. Go check it out at https://example.site/example."
 *         },
 *         info: "Starting job to submit action to webhook.site",
 *         managed: true
 *     }
 */
export interface Job extends Flatfile.JobConfig {
    id: Flatfile.JobId;
    /** The user, guest, or agent who created the job */
    createdBy: Flatfile.ActorId;
    /** Date the item was created */
    createdAt: Date;
    /** Date the item was last updated */
    updatedAt: Date;
    /** the time that the job started at */
    startedAt?: Date;
    /** the time that the job finished at */
    finishedAt?: Date;
    /** the time that the job's outcome has been acknowledged by a user */
    outcomeAcknowledgedAt?: Date;
}
