/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Flatfile from "../../../index";
/**
 * A single unit of work that a pipeline will execute
 *
 * @example
 *     {
 *         type: Flatfile.JobType.Workbook,
 *         operation: "submitAction",
 *         source: "us_wb_YOUR_ID"
 *     }
 */
export interface JobConfig {
    /** The type of job */
    type: Flatfile.JobType;
    /** the type of operation to perform on the data. For example, "export". */
    operation: string;
    source: Flatfile.JobSource;
    destination?: Flatfile.JobDestination;
    config?: Flatfile.JobUpdateConfig;
    /** the type of trigger to use for this job */
    trigger?: Flatfile.Trigger;
    /** the status of the job */
    status?: Flatfile.JobStatus;
    /** the progress of the job. Whole number between 0 and 100 */
    progress?: number;
    fileId?: Flatfile.FileId;
    /** the mode of the job */
    mode?: Flatfile.JobMode;
    /** Input parameters for this job type. */
    input?: Record<string, any>;
    /** Subject parameters for this job type. */
    subject?: Flatfile.JobSubject;
    /** Outcome summary of job. */
    outcome?: Record<string, any>;
    /** Current status of job in text */
    info?: string;
    /** Indicates if Flatfile is managing the control flow of this job or if it is being manually tracked. */
    managed?: boolean;
    /** The id of the environment this job belongs to */
    environmentId?: Flatfile.EnvironmentId;
    /** The part number of this job */
    part?: number;
    /** The data for this part of the job */
    partData?: Record<string, any>;
    /** The execution mode for this part of the job */
    partExecution?: Flatfile.JobPartExecution;
    /** The id of the parent job */
    parentId?: Flatfile.JobId;
    /** The ids of the jobs that must complete before this job can start */
    predecessorIds?: Flatfile.JobId[];
    /** Additional metadata for the job */
    metadata?: Record<string, any>;
}
