/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as Flatfile from "../../../index";
export declare namespace Roles {
    interface Options {
        environment?: core.Supplier<environments.FlatfileEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        token?: core.Supplier<core.BearerToken | undefined>;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Roles {
    protected readonly _options: Roles.Options;
    constructor(_options?: Roles.Options);
    /**
     * List all roles for an account
     *
     * @param {Roles.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.roles.list()
     */
    list(requestOptions?: Roles.RequestOptions): core.HttpResponsePromise<Flatfile.ListRolesResponse>;
    private __list;
    protected _getAuthorizationHeader(): Promise<string | undefined>;
}
