/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Flatfile from "../../../index";
/**
 * Runbook
 *
 * @example
 *     {
 *         id: "us_rb_YOUR_ID",
 *         accountId: "us_acc_YOUR_ID",
 *         appId: "us_app_YOUR_ID",
 *         environmentId: "us_env_YOUR_ID",
 *         spaceId: "us_sp_YOUR_ID",
 *         name: "Runbook Name",
 *         config: {
 *             sourceSheetIds: ["us_sh_YOUR_ID"],
 *             destinationSheetIds: ["us_sh_YOUR_ID"]
 *         },
 *         status: Flatfile.RunbookStatus.Created,
 *         type: Flatfile.RunbookType.Preprocessing,
 *         createdBy: "us_usr_YOUR_ID",
 *         updatedAt: "2024-12-05T18:00:00Z",
 *         createdAt: "2024-12-05T18:00:00Z"
 *     }
 */
export interface Runbook {
    /** The ID of the Runbook. */
    id: Flatfile.RunbookId;
    accountId: Flatfile.AccountId;
    appId: Flatfile.AppId;
    environmentId: Flatfile.EnvironmentId;
    spaceId: Flatfile.SpaceId;
    /** The name of the Runbook. */
    name: string;
    /** The configuration of the Runbook. */
    config: Flatfile.RunbookConfig;
    /** The status of the Runbook. */
    status: Flatfile.RunbookStatus;
    /** The type of the Runbook. */
    type: Flatfile.RunbookType;
    /** The entity which created the Runbook. */
    createdBy: string;
    /** Date the sheet was created */
    createdAt: Date;
    /** Date the sheet was last updated */
    updatedAt: Date;
}
