/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Flatfile from "../../../index";
/**
 * @example
 *     {
 *         id: "us_ss_YOUR_ID",
 *         sheetId: "us_sh_YOUR_ID",
 *         label: "My snapshot",
 *         summary: {
 *             createdSince: {
 *                 total: 0
 *             },
 *             updatedSince: {
 *                 total: 5,
 *                 byField: {
 *                     "lastName": 5
 *                 }
 *             },
 *             deletedSince: {
 *                 total: 5,
 *                 byField: {
 *                     "firstName": 1
 *                 }
 *             },
 *             schemaDiff: {
 *                 "firstName": Flatfile.SchemaDiffEnum.Added,
 *                 "lastName": Flatfile.SchemaDiffEnum.Removed,
 *                 "email": Flatfile.SchemaDiffEnum.Unchanged
 *             },
 *             config: {
 *                 name: "Contacts",
 *                 slug: "contacts",
 *                 fields: [{
 *                         type: "string",
 *                         key: "firstName",
 *                         label: "First Name"
 *                     }, {
 *                         type: "string",
 *                         key: "lastName",
 *                         label: "Last Name"
 *                     }, {
 *                         type: "string",
 *                         key: "email",
 *                         label: "Email"
 *                     }],
 *                 mappingConfidenceThreshold: 0.5
 *             }
 *         },
 *         createdAt: "2023-01-01T00:00:00Z",
 *         createdBy: "us_usr_YOUR_ID"
 *     }
 */
export interface Snapshot {
    /** The ID of the Snapshot. */
    id: Flatfile.SnapshotId;
    /** The ID of the Sheet. */
    sheetId: Flatfile.SheetId;
    /** The title of the Snapshot. */
    label?: string;
    /** The ID of the thread associated with the snapshot. */
    threadId?: string;
    /** A summary of the Snapshot. This field is only available on the single get snapshot endpoint. It is not available for the list snapshots endpoint. */
    summary?: Flatfile.SnapshotSummary;
    /** The time the Snapshot was created. */
    createdAt: Date;
    /** The actor who created the Snapshot. */
    createdBy: Flatfile.UserId;
}
