/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Flatfile from "../../../index";
/**
 * A place to store your workbooks
 *
 * @example
 *     {
 *         id: "us_sp_YOUR_ID",
 *         name: "My First Worbook",
 *         displayOrder: 1,
 *         createdAt: "2021-01-01T00:00:00.000Z",
 *         updatedAt: "2021-01-01T00:00:00.000Z",
 *         lastActivityAt: "2021-01-01T00:00:00.000Z",
 *         createdByUserId: "us_usr_YOUR_ID",
 *         workbooksCount: 1,
 *         filesCount: 1,
 *         isCollaborative: true,
 *         upgradedAt: "2021-01-01T00:00:00.000Z",
 *         guestAuthentication: [Flatfile.GuestAuthenticationEnum.MagicLink, Flatfile.GuestAuthenticationEnum.SharedLink],
 *         environmentId: "us_env_YOUR_ID",
 *         primaryWorkbookId: "us_wb_YOUR_ID",
 *         labels: []
 *     }
 *
 * @example
 *     {
 *         id: "us_sp_YOUR_ID",
 *         name: "My Updated Worbook",
 *         displayOrder: 1,
 *         createdAt: "2021-01-01T00:00:00.000Z",
 *         updatedAt: "2021-01-01T00:00:00.000Z",
 *         lastActivityAt: "2021-01-01T00:00:00.000Z",
 *         createdByUserId: "us_usr_YOUR_ID",
 *         workbooksCount: 1,
 *         filesCount: 1,
 *         isCollaborative: true,
 *         upgradedAt: "2021-01-01T00:00:00.000Z",
 *         guestAuthentication: [Flatfile.GuestAuthenticationEnum.MagicLink, Flatfile.GuestAuthenticationEnum.SharedLink],
 *         environmentId: "us_env_YOUR_ID",
 *         primaryWorkbookId: "us_wb_YOUR_ID",
 *         labels: []
 *     }
 */
export interface Space extends Flatfile.InternalSpaceConfigBase {
    id: Flatfile.SpaceId;
    /** Amount of workbooks in the space */
    workbooksCount?: number;
    /** Amount of files in the space */
    filesCount?: number;
    createdByUserId?: Flatfile.UserId;
    /** User name who created space */
    createdByUserName?: string;
    /** Date when space was created */
    createdAt: Date;
    /** Date when space was updated */
    updatedAt: Date;
    /** Date when space was expired */
    expiredAt?: Date;
    /** This date marks the most recent activity within the space, tracking actions to the second. Activities include creating or updating records in a sheet, uploading files, or modifying a workbook's configuration. */
    lastActivityAt?: Date;
    /** Guest link to the space */
    guestLink?: string;
    /** The name of the space */
    name: string;
    /** The display order */
    displayOrder?: number;
    /** Access token for the space */
    accessToken?: string;
    /** Flag for collaborative (project) spaces */
    isCollaborative?: boolean;
    /** Size information for the space */
    size?: Flatfile.SpaceSize;
    /** Date when the space was upgraded */
    upgradedAt?: Date;
    /** Type of guest authentication */
    guestAuthentication: Flatfile.GuestAuthenticationEnum[];
    /** The space id of the template that was used to create this space */
    createdFrom?: Flatfile.SpaceId;
    /** The last time the space template configuration was propagated to this space */
    lastPropagatedAt?: Date;
}
