/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as Flatfile from "../../../index";
export declare namespace Transformations {
    interface Options {
        environment?: core.Supplier<environments.FlatfileEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        token?: core.Supplier<core.BearerToken | undefined>;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Disable-Hooks header */
        xDisableHooks?: "true";
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Transformations {
    protected readonly _options: Transformations.Options;
    constructor(_options?: Transformations.Options);
    /**
     * @param {Flatfile.ListTransformationsRequest} request
     * @param {Transformations.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.transformations.list({
     *         appId: "appId",
     *         matchKeys: ["matchKeys", "matchKeys"]
     *     })
     */
    list(request: Flatfile.ListTransformationsRequest, requestOptions?: Transformations.RequestOptions): core.HttpResponsePromise<Flatfile.TransformationsResponse>;
    private __list;
    /**
     * @param {Flatfile.TransformationCreateDto} request
     * @param {Transformations.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.transformations.create({
     *         accountId: "accountId",
     *         environmentId: "environmentId",
     *         spaceId: "spaceId",
     *         appId: "appId",
     *         programId: "programId",
     *         keys: ["keys", "keys"],
     *         sourceKeys: ["sourceKeys", "sourceKeys"],
     *         destinationKeys: ["destinationKeys", "destinationKeys"],
     *         transformationFunction: "transformationFunction",
     *         mutationCommand: "mutationCommand"
     *     })
     */
    create(request: Flatfile.TransformationCreateDto, requestOptions?: Transformations.RequestOptions): core.HttpResponsePromise<Flatfile.TransformationResponse>;
    private __create;
    /**
     * @param {Flatfile.TransformationId} transformationId - The id of the transformation to update
     * @param {Flatfile.TransformationCreateDto} request
     * @param {Transformations.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.transformations.update("transformationId", {
     *         accountId: "accountId",
     *         environmentId: "environmentId",
     *         spaceId: "spaceId",
     *         appId: "appId",
     *         programId: "programId",
     *         keys: ["keys", "keys"],
     *         sourceKeys: ["sourceKeys", "sourceKeys"],
     *         destinationKeys: ["destinationKeys", "destinationKeys"],
     *         transformationFunction: "transformationFunction",
     *         mutationCommand: "mutationCommand"
     *     })
     */
    update(transformationId: Flatfile.TransformationId, request: Flatfile.TransformationCreateDto, requestOptions?: Transformations.RequestOptions): core.HttpResponsePromise<Flatfile.TransformationResponse>;
    private __update;
    /**
     * @param {Flatfile.TransformationId} transformationId - The id of the transformation to delete
     * @param {Transformations.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.transformations.delete("transformationId")
     */
    delete(transformationId: Flatfile.TransformationId, requestOptions?: Transformations.RequestOptions): core.HttpResponsePromise<Flatfile.Success>;
    private __delete;
    protected _getAuthorizationHeader(): Promise<string | undefined>;
}
