/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Flatfile from "../../../index";
/**
 * The updates to be made to an existing workbook
 *
 * @example
 *     {
 *         name: "My Updated Workbook",
 *         labels: ["my-new-label"],
 *         actions: [{
 *                 operation: "submitAction",
 *                 mode: Flatfile.ActionMode.Foreground,
 *                 label: "Submit Changes",
 *                 description: "Submit data to webhook.site",
 *                 primary: true
 *             }]
 *     }
 */
export interface WorkbookUpdate {
    /** The name of the Workbook. */
    name?: string;
    /** An optional list of labels for the Workbook. */
    labels?: string[];
    /** The Space Id associated with the Workbook. */
    spaceId?: Flatfile.SpaceId;
    /** The Environment Id associated with the Workbook. */
    environmentId?: Flatfile.EnvironmentId;
    /** The namespace of the Workbook. */
    namespace?: string;
    /** Describes shape of data as well as behavior */
    sheets?: Flatfile.SheetConfigOrUpdate[];
    actions?: Flatfile.Action[];
    /** Metadata for the workbook */
    metadata?: any;
    /** The Workbook settings. */
    settings?: Flatfile.WorkbookConfigSettings;
}
