"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FlatfileClient = void 0;
const cross_env_config_1 = require("@flatfile/cross-env-config");
const url_join_1 = __importDefault(require("url-join"));
const Client_1 = require("../Client");
const environments = __importStar(require("../environments"));
const RecordsClient_1 = require("./RecordsClient");
cross_env_config_1.CrossEnvConfig.alias("FLATFILE_API_URL", "AGENT_INTERNAL_URL");
cross_env_config_1.CrossEnvConfig.alias("FLATFILE_BEARER_TOKEN", "FLATFILE_API_KEY");
class FlatfileClient extends Client_1.FlatfileClient {
    constructor(options = {}) {
        var _a;
        super({
            environment: resolveEnvironment(options),
            token: (_a = options.token) !== null && _a !== void 0 ? _a : tokenSupplier,
        });
    }
    get records() {
        var _a;
        return ((_a = this._records) !== null && _a !== void 0 ? _a : (this._records = new RecordsClient_1.Records(this._options)));
    }
}
exports.FlatfileClient = FlatfileClient;
const resolveEnvironment = (options) => {
    if (options.apiUrl && !options.apiUrl.endsWith("/v1")) {
        return (0, url_join_1.default)(options.apiUrl, "v1");
    }
    return options.environment || options.apiUrl || environmentSupplier();
};
const environmentSupplier = () => {
    const url = cross_env_config_1.CrossEnvConfig.get("FLATFILE_API_URL");
    if (!url) {
        return environments.FlatfileEnvironment.Production;
    }
    return (0, url_join_1.default)(url, "v1");
};
const tokenSupplier = () => {
    const token = cross_env_config_1.CrossEnvConfig.get("FLATFILE_BEARER_TOKEN");
    if (token === undefined) {
        throw new Error("FLATFILE_BEARER_TOKEN is undefined");
    }
    return token;
};
