/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as serializers from "../../../index";
import * as Flatfile from "../../../../api/index";
import * as core from "../../../../core";
import { GenericEvent } from "./GenericEvent";
export declare const Event: core.serialization.Schema<serializers.Event.Raw, Flatfile.Event>;
export declare namespace Event {
    type Raw = Event.AgentCreated | Event.AgentUpdated | Event.AgentDeleted | Event.SpaceCreated | Event.SpaceUpdated | Event.SpaceDeleted | Event.SpaceArchived | Event.SpaceExpired | Event.SpaceGuestAdded | Event.SpaceGuestRemoved | Event.DocumentCreated | Event.DocumentUpdated | Event.DocumentDeleted | Event.WorkbookCreated | Event.WorkbookUpdated | Event.WorkbookDeleted | Event.WorkbookExpired | Event.SheetCreated | Event.SheetUpdated | Event.SheetDeleted | Event.SheetCountsUpdated | Event.SheetCalculationUpdated | Event.SnapshotCreated | Event.RecordsCreated | Event.RecordsUpdated | Event.RecordsDeleted | Event.FileCreated | Event.FileUpdated | Event.FileDeleted | Event.FileExpired | Event.JobCreated | Event.JobUpdated | Event.JobDeleted | Event.JobFailed | Event.JobCompleted | Event.JobReady | Event.JobScheduled | Event.JobOutcomeAcknowledged | Event.JobPartsCompleted | Event.ProgramCreated | Event.ProgramUpdated | Event.CommitCreated | Event.CommitUpdated | Event.CommitCompleted | Event.SecretCreated | Event.SecretUpdated | Event.SecretDeleted | Event.LayerCreated | Event.EnvironmentCreated | Event.EnvironmentUpdated | Event.EnvironmentDeleted | Event.EnvironmentAutobuildCreated | Event.ActionCreated | Event.ActionUpdated | Event.ActionDeleted | Event.DataClipCreated | Event.DataClipUpdated | Event.DataClipDeleted | Event.DataClipCollaboratorUpdated | Event.DataClipResolutionsCreated | Event.DataClipResolutionsUpdated | Event.DataClipResolutionsRefreshed | Event.CanvasCreated | Event.CanvasUpdated | Event.CanvasDeleted | Event.CanvasAreaCreated | Event.CanvasAreaUpdated | Event.CanvasAreaDeleted;
    interface AgentCreated extends GenericEvent.Raw {
        topic: "agent:created";
    }
    interface AgentUpdated extends GenericEvent.Raw {
        topic: "agent:updated";
    }
    interface AgentDeleted extends GenericEvent.Raw {
        topic: "agent:deleted";
    }
    interface SpaceCreated extends GenericEvent.Raw {
        topic: "space:created";
    }
    interface SpaceUpdated extends GenericEvent.Raw {
        topic: "space:updated";
    }
    interface SpaceDeleted extends GenericEvent.Raw {
        topic: "space:deleted";
    }
    interface SpaceArchived extends GenericEvent.Raw {
        topic: "space:archived";
    }
    interface SpaceExpired extends GenericEvent.Raw {
        topic: "space:expired";
    }
    interface SpaceGuestAdded extends GenericEvent.Raw {
        topic: "space:guestAdded";
    }
    interface SpaceGuestRemoved extends GenericEvent.Raw {
        topic: "space:guestRemoved";
    }
    interface DocumentCreated extends GenericEvent.Raw {
        topic: "document:created";
    }
    interface DocumentUpdated extends GenericEvent.Raw {
        topic: "document:updated";
    }
    interface DocumentDeleted extends GenericEvent.Raw {
        topic: "document:deleted";
    }
    interface WorkbookCreated extends GenericEvent.Raw {
        topic: "workbook:created";
    }
    interface WorkbookUpdated extends GenericEvent.Raw {
        topic: "workbook:updated";
    }
    interface WorkbookDeleted extends GenericEvent.Raw {
        topic: "workbook:deleted";
    }
    interface WorkbookExpired extends GenericEvent.Raw {
        topic: "workbook:expired";
    }
    interface SheetCreated extends GenericEvent.Raw {
        topic: "sheet:created";
    }
    interface SheetUpdated extends GenericEvent.Raw {
        topic: "sheet:updated";
    }
    interface SheetDeleted extends GenericEvent.Raw {
        topic: "sheet:deleted";
    }
    interface SheetCountsUpdated extends GenericEvent.Raw {
        topic: "sheet:counts-updated";
    }
    interface SheetCalculationUpdated extends GenericEvent.Raw {
        topic: "sheet:calculation-updated";
    }
    interface SnapshotCreated extends GenericEvent.Raw {
        topic: "snapshot:created";
    }
    interface RecordsCreated extends GenericEvent.Raw {
        topic: "records:created";
    }
    interface RecordsUpdated extends GenericEvent.Raw {
        topic: "records:updated";
    }
    interface RecordsDeleted extends GenericEvent.Raw {
        topic: "records:deleted";
    }
    interface FileCreated extends GenericEvent.Raw {
        topic: "file:created";
    }
    interface FileUpdated extends GenericEvent.Raw {
        topic: "file:updated";
    }
    interface FileDeleted extends GenericEvent.Raw {
        topic: "file:deleted";
    }
    interface FileExpired extends GenericEvent.Raw {
        topic: "file:expired";
    }
    interface JobCreated extends GenericEvent.Raw {
        topic: "job:created";
    }
    interface JobUpdated extends GenericEvent.Raw {
        topic: "job:updated";
    }
    interface JobDeleted extends GenericEvent.Raw {
        topic: "job:deleted";
    }
    interface JobFailed extends GenericEvent.Raw {
        topic: "job:failed";
    }
    interface JobCompleted extends GenericEvent.Raw {
        topic: "job:completed";
    }
    interface JobReady extends GenericEvent.Raw {
        topic: "job:ready";
    }
    interface JobScheduled extends GenericEvent.Raw {
        topic: "job:scheduled";
    }
    interface JobOutcomeAcknowledged extends GenericEvent.Raw {
        topic: "job:outcome-acknowledged";
    }
    interface JobPartsCompleted extends GenericEvent.Raw {
        topic: "job:parts-completed";
    }
    interface ProgramCreated extends GenericEvent.Raw {
        topic: "program:created";
    }
    interface ProgramUpdated extends GenericEvent.Raw {
        topic: "program:updated";
    }
    interface CommitCreated extends GenericEvent.Raw {
        topic: "commit:created";
    }
    interface CommitUpdated extends GenericEvent.Raw {
        topic: "commit:updated";
    }
    interface CommitCompleted extends GenericEvent.Raw {
        topic: "commit:completed";
    }
    interface SecretCreated extends GenericEvent.Raw {
        topic: "secret:created";
    }
    interface SecretUpdated extends GenericEvent.Raw {
        topic: "secret:updated";
    }
    interface SecretDeleted extends GenericEvent.Raw {
        topic: "secret:deleted";
    }
    interface LayerCreated extends GenericEvent.Raw {
        topic: "layer:created";
    }
    interface EnvironmentCreated extends GenericEvent.Raw {
        topic: "environment:created";
    }
    interface EnvironmentUpdated extends GenericEvent.Raw {
        topic: "environment:updated";
    }
    interface EnvironmentDeleted extends GenericEvent.Raw {
        topic: "environment:deleted";
    }
    interface EnvironmentAutobuildCreated extends GenericEvent.Raw {
        topic: "environment:autobuild-created";
    }
    interface ActionCreated extends GenericEvent.Raw {
        topic: "action:created";
    }
    interface ActionUpdated extends GenericEvent.Raw {
        topic: "action:updated";
    }
    interface ActionDeleted extends GenericEvent.Raw {
        topic: "action:deleted";
    }
    interface DataClipCreated extends GenericEvent.Raw {
        topic: "data-clip:created";
    }
    interface DataClipUpdated extends GenericEvent.Raw {
        topic: "data-clip:updated";
    }
    interface DataClipDeleted extends GenericEvent.Raw {
        topic: "data-clip:deleted";
    }
    interface DataClipCollaboratorUpdated extends GenericEvent.Raw {
        topic: "data-clip:collaborator-updated";
    }
    interface DataClipResolutionsCreated extends GenericEvent.Raw {
        topic: "data-clip:resolutions-created";
    }
    interface DataClipResolutionsUpdated extends GenericEvent.Raw {
        topic: "data-clip:resolutions-updated";
    }
    interface DataClipResolutionsRefreshed extends GenericEvent.Raw {
        topic: "data-clip:resolutions-refreshed";
    }
    interface CanvasCreated extends GenericEvent.Raw {
        topic: "canvas:created";
    }
    interface CanvasUpdated extends GenericEvent.Raw {
        topic: "canvas:updated";
    }
    interface CanvasDeleted extends GenericEvent.Raw {
        topic: "canvas:deleted";
    }
    interface CanvasAreaCreated extends GenericEvent.Raw {
        topic: "canvas-area:created";
    }
    interface CanvasAreaUpdated extends GenericEvent.Raw {
        topic: "canvas-area:updated";
    }
    interface CanvasAreaDeleted extends GenericEvent.Raw {
        topic: "canvas-area:deleted";
    }
}
